## seetaface-tracker 1.0.0.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
set(FaceTracking_NAME "SeetaFaceTracking" CACHE STRING "The FaceTracking library name")
set(FaceTracking_VERSION_MAJOR "6")
set(FaceTracking_VERSION_MINOR "0")
set(FaceTracking_VERSION_SINOR "0")
set(FaceTracking_VERSION "${FaceTracking_VERSION_MAJOR}${FaceTracking_VERSION_MINOR}${FaceTracking_VERSION_SINOR}")
project(${FaceTracking_NAME}${FaceTracking_VERSION})
#set(CMAKE_VERBOSE_MAKEFILE on)

set(SOLUTION_DIR ${CMAKE_CURRENT_SOURCE_DIR})

# option for platform
set(PLATFORM "x64" CACHE STRING "x86 or x64")
set(CONFIGURATION "Debug" CACHE STRING "Debug or Release")
set(CONFIGURATION ${CMAKE_BUILD_TYPE})

# option for shared or static
set(TARGET "SHARED" CACHE STRING "SHARED or STATIC" FORCE)
# option for SeetaAuthorize
option(SEETA_AUTHORIZE "Using seeta authorize" ON)
# option for build android
option(BUILD_ANDROID "Buid android" OFF)
message(STATUS "Build android: " ${BUILD_ANDROID})

# gether moduls
list(APPEND CMAKE_MODULE_PATH ${SOLUTION_DIR}/cmake)
list(APPEND CMAKE_MODULE_PATH ${SOLUTION_DIR}/../build/cmake)
message(STATUS "CMAKE_MODULE_PATH: ${CMAKE_MODULE_PATH}")

# install dir
set(CMAKE_INSTALL_PREFIX ${SOLUTION_DIR}/../build CACHE STRING "set install prefix" FORCE)
set(SEETA_INSTALL_PATH "" CACHE STRING "seeta install path")
if(SEETA_INSTALL_PATH STREQUAL "")
else()
	set(CMAKE_INSTALL_PREFIX ${SEETA_INSTALL_PATH} CACHE STRING "set install prefix" FORCE)
endif()
message(STATUS "cmake install prefix: ${CMAKE_INSTALL_PREFIX}")

# set base flags
set(CMAKE_CFLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden -w")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden -w -std=c++11")

# env
include(LOCAL_ENV)
include(INC_ORZ)

if ("${PLATFORM}" STREQUAL "x86")
    message(STATUS "Platform: " ${PLATFORM})
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -m32")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m32")
elseif ("${PLATFORM}" STREQUAL "x64")
    message(STATUS "Platform: " ${PLATFORM})
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -m64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m64")
else()
	message(STATUS "Platform: " ${PLATFORM})
endif()

if ("${CONFIGURATION}" STREQUAL "Debug")
    message(STATUS "Configuration: " ${CONFIGURATION})
    set(CMAKE_CX_FLAGS "${CMAKE_CX_FLAGS} -O0 -g -ggdb")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0 -g -ggdb")
else()
    message(STATUS "Configuration: " ${CONFIGURATION})
    set(CMAKE_CX_FLAGS "${CMAKE_CX_FLAGS} -O3")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3")
endif()

add_subdirectory(${SOLUTION_DIR}/FaceTracking)
if(NOT BUILD_ANDROID)
	#add_subdirectory(${SOLUTION_DIR}/example)
endif()

=== FaceTracking/CMakeLists.txt ===
# library in subdir

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")

add_definitions(-DSEETA_EXPORTS)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)

file(GLOB_RECURSE ROOT_SRC_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/src/*.c
    ${CMAKE_CURRENT_SOURCE_DIR}/src/*.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/src/*.cpp
    )
	
	
file(GLOB_RECURSE COMMON_INCLUDE_FILES
	${CMAKE_CURRENT_SOURCE_DIR}/include/seeta/Common/*.h
    ${CMAKE_CURRENT_SOURCE_DIR}/include/seeta/Common/*.hh
    ${CMAKE_CURRENT_SOURCE_DIR}/include/seeta/Common/*.hpp
	)

file(GLOB_RECURSE ROOT_SEETA_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/seeta/*.c
    ${CMAKE_CURRENT_SOURCE_DIR}/seeta/*.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/seeta/*.cpp
    )

file(GLOB INCLUDE_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/include/seeta/*.h
    ${CMAKE_CURRENT_SOURCE_DIR}/include/seeta/*.hh
    ${CMAKE_CURRENT_SOURCE_DIR}/include/seeta/*.hpp
    )

	
list(APPEND SRC_FILES ${ROOT_SRC_FILES})
list(APPEND SRC_FILES ${ROOT_SEETA_FILES})

# add library
add_library(${PROJECT_NAME} ${TARGET} ${SRC_FILES})

find_package(SeetaFaceDetector REQUIRED)
include_directories(${SeetaFaceDetector_INCLUDE_DIRS})
target_link_libraries(${PROJECT_NAME} ${SeetaFaceDetector_LIBRARIES})
# link ORZ
target_link_libraries(${PROJECT_NAME} ORZ_static${ENV_SUFFIX})

# set library properties
if ("${CONFIGURATION}" STREQUAL "Debug")
    set_target_properties(${PROJECT_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME}d)
else()
    set_target_properties(${PROJECT_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME})
endif()

# build dir
set(OUT_DIR ${SOLUTION_DIR}/build)
#set(OUT_DIR ${SEETA_INSTALL_PATH}/${SeetaFaceTracking_NAME})

#create install dir
file(MAKE_DIRECTORY ${OUT_DIR})

set(LIBRARY_OUTPUT_PATH ${OUT_DIR}/${ENV_LIBRARY_DIR})
set(ARCHIVE_OUTPUT_PATH ${OUT_DIR}/${ENV_LIBRARY_DIR})
# add command to copy header files
add_custom_command(TARGET ${PROJECT_NAME}
        PRE_BUILD
        COMMAND ${CMAKE_COMMAND} -E make_directory ${OUT_DIR}/${ENV_INCLUDE_DIR}
        )
add_custom_command(TARGET ${PROJECT_NAME}
        PRE_BUILD
        COMMAND ${CMAKE_COMMAND} -E make_directory ${OUT_DIR}/${ENV_INCLUDE_DIR}/seeta
        )

add_custom_command(TARGET ${PROJECT_NAME}
        PRE_BUILD
        COMMAND ${CMAKE_COMMAND} -E make_directory ${OUT_DIR}/${ENV_INCLUDE_DIR}/seeta/Common
        )
# copy every header files
foreach(header ${INCLUDE_FILES})
    add_custom_command(TARGET ${PROJECT_NAME}
            POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E copy_if_different ${header} ${OUT_DIR}/${ENV_INCLUDE_DIR}/seeta
            )
endforeach()
foreach(header ${COMMON_INCLUDE_FILES})
    add_custom_command(TARGET ${PROJECT_NAME}
            POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E copy_if_different ${header} ${OUT_DIR}/${ENV_INCLUDE_DIR}/seeta/Common
            )
endforeach()

#install
#update and install cmake file
configure_file(${SOLUTION_DIR}/cmake/FindSeetaFaceTracking.cmake.in ${SOLUTION_DIR}/cmake/FindSeetaFaceTracking.cmake @ONLY)
file(GLOB_RECURSE FIND_CMAKE_FILES
    ${SOLUTION_DIR}/cmake/FindSeetaFaceTracking.cmake
    )
install(FILES ${FIND_CMAKE_FILES} DESTINATION cmake)	

message(STATUS "install targets library: " ${PROJECT_NAME})

install(TARGETS ${PROJECT_NAME}
	RUNTIME DESTINATION ${ENV_RUNTIME_DIR}
	LIBRARY DESTINATION ${ENV_LIBRARY_DIR}
	ARCHIVE DESTINATION ${ENV_ARCHIVE_DIR}
)

message("destination:" ${CMAKE_INSTALL_PREFIX})
install(FILES ${COMMON_INCLUDE_FILES} DESTINATION ${ENV_INCLUDE_DIR}/seeta/Common)
install(FILES ${INCLUDE_FILES} DESTINATION ${ENV_INCLUDE_DIR}/seeta)

=== example/CMakeLists.txt ===
# test

SET(TEST_PROJECT_NAME example)

file(GLOB_RECURSE TEST_SRC_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/*.c
    ${CMAKE_CURRENT_SOURCE_DIR}/*.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/*.cpp
    )

add_executable(${TEST_PROJECT_NAME} ${TEST_SRC_FILES})

set(OUT_DIR ${SOLUTION_DIR}/build)

include_directories(${OUT_DIR}/${ENV_INCLUDE_DIR})

set_target_properties(${TEST_PORJECT_NAME} PROPERTIES OUTPUT_NAME ${TEST_PROJECT_NAME}${ENV_SUFFIX})

#set(EXECUTABLE_OUTPUT_PATH ${OUT_DIR}/${ENV_RUNTIME_DIR})
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_SOURCE_DIR}/${ENV_RUNTIME_DIR})

#target_link_libraries(${TEST_PROJECT_NAME} ${PROJECT_NAME}_SHARED)

#target_link_libraries(${TEST_PROJECT_NAME} -lTensorStack)

link_directories(${OUT_DIR}/${ENV_LIBRARY_DIR})

#link_directories("/wqy/seeta_sdk/sdk/sdk6.0/common/seetaauthorize/lib64")
#link_directories("/wqy/seeta_sdk/sdk/sdk6.0/common/tensorstack/lib64")
#link_directories("/wqy/seeta_sdk/sdk/sdk6.0/common/faceboxes/lib64")

target_link_libraries(${TEST_PROJECT_NAME} ${PROJECT_NAME})



find_package(OpenCV)

if (OpenCV_FOUND)
    include_directories(${OpenCV_INCLUDES})
    target_link_libraries(${TEST_PROJECT_NAME} ${OpenCV_LIBRARIES})
else ()
    message(WARNING "Can not find OpenCV libraries, make ${TEST_PROJECT_NAME} would failed.")
endif ()

=== debian/changelog ===
seetaface-tracker (1.0.0.2-1+dde) unstable; urgency=medium

  * Fix conflict files with seetaface-boxes

 -- chenlinxuan <chenlinxuan@uniontech.com>  Fri, 10 Dec 2021 13:25:23 +0800

seetaface-tracker (1.0.0.1-1+dde) unstable; urgency=medium

  * Fix build issue

 -- chenlinxuan <chenlinxuan@uniontech.com>  Thu, 09 Dec 2021 21:00:26 +0800

seetaface-tracker (1.0.0-1) unstable; urgency=medium

  * Initial release 

 -- liujianqing <liujianqiang@uniontech.com>  Fri, 03 Dec 2021 17:08:50 +0800

=== debian/control ===
Source: seetaface-tracker
Section: devel
Priority: optional
Maintainer: bd <bd@seetatech.com>
Build-Depends: debhelper (>= 11),
 libopencv-dev,
 cmake,
 seetaface-open-role-zoo,
 seetaface-authorize,
 seetaface-tennis,
 seetaface-boxes
Standards-Version: 4.5.1
Homepage: https://github.com/SeetaFace6Open/FaceTracker6.git
Rules-Requires-Root: no

Package: seetaface-tracker
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: tracker for seetaface
 tracker module for seetaface.
